// Generated by delombok at Mon Sep 30 19:31:26 UTC 2024
package gov.cms.fiss.pricers.ipps.api.v2;

import gov.cms.fiss.pricers.common.api.serialization.BigDecimalScale;
import gov.cms.fiss.pricers.common.api.validation.ValidSignedDecimalOutputWithTwoFractionDigits;
import io.swagger.v3.oas.annotations.extensions.Extension;
import io.swagger.v3.oas.annotations.extensions.ExtensionProperty;
import io.swagger.v3.oas.annotations.media.Schema;
import java.math.BigDecimal;
import java.math.RoundingMode;

@Schema(description = "The additional payment variable information from claim pricing.", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "PPS-ADDITIONAL-PAY-INFO-DATA", value = "<structure>")}), @Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "PPS-ADDITIONAL-PAY-INFO-DATA2", value = "<structure>")})})
public class AdditionalPaymentInformationData {
  @BigDecimalScale(roundingMode = RoundingMode.HALF_UP)
  @Schema(description = "The bundled adjustment payment.", example = "665423.45", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "PPS-BUNDLE-ADJUST-AMT", value = "PIC S9(07)V9(02)")})})
  @ValidSignedDecimalOutputWithTwoFractionDigits
  private BigDecimal bundledAdjustmentPayment;
  @BigDecimalScale(roundingMode = RoundingMode.HALF_UP)
  @Schema(description = "The electronic health record adjustment payment.", example = "6542.54", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "PPS-EHR-ADJUST-AMT", value = "PIC S9(07)V9(02)")})})
  @ValidSignedDecimalOutputWithTwoFractionDigits
  private BigDecimal electronicHealthRecordAdjustmentPayment;
  @BigDecimalScale(roundingMode = RoundingMode.HALF_UP)
  @Schema(description = "The hospital-acquired condition payment.", example = "5644.25", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "PPS-HAC-PAYMENT-AMT", value = "PIC S9(07)V9(02)")})})
  @ValidSignedDecimalOutputWithTwoFractionDigits
  private BigDecimal hospitalAcquiredConditionPayment;
  @BigDecimalScale(roundingMode = RoundingMode.HALF_UP)
  @Schema(description = "The hospital readmission reduction adjustment payment.", example = "564.23", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "PPS-READMIS-ADJUST-AMT", value = "PIC S9(07)V9(02)")})})
  @ValidSignedDecimalOutputWithTwoFractionDigits
  private BigDecimal hospitalReadmissionReductionAdjustmentPayment;
  @BigDecimalScale(roundingMode = RoundingMode.HALF_UP)
  @Schema(description = "The standard value.", example = "90384.75", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "PPS-STNDRD-VALUE", value = "PIC S9(07)V9(02)")})})
  @ValidSignedDecimalOutputWithTwoFractionDigits
  private BigDecimal standardValue;
  @BigDecimalScale(roundingMode = RoundingMode.HALF_UP)
  @Schema(description = "The uncompensated care payment.", example = "2365.42", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "PPS-UNCOMP-CARE-AMOUNT", value = "PIC S9(07)V9(02)")})})
  @ValidSignedDecimalOutputWithTwoFractionDigits
  private BigDecimal uncompensatedCarePayment;
  @BigDecimalScale(roundingMode = RoundingMode.HALF_UP)
  @Schema(description = "The value-based purchasing adjustment payment.", example = "90384.75", extensions = {@Extension(name = "cobol-declaration", properties = {@ExtensionProperty(name = "PPS-VAL-BASED-PURCH-ADJUST-AMT", value = "PIC S9(07)V9(02)")})})
  @ValidSignedDecimalOutputWithTwoFractionDigits
  private BigDecimal valueBasedPurchasingAdjustmentPayment;

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getBundledAdjustmentPayment() {
    return this.bundledAdjustmentPayment;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getElectronicHealthRecordAdjustmentPayment() {
    return this.electronicHealthRecordAdjustmentPayment;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getHospitalAcquiredConditionPayment() {
    return this.hospitalAcquiredConditionPayment;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getHospitalReadmissionReductionAdjustmentPayment() {
    return this.hospitalReadmissionReductionAdjustmentPayment;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getStandardValue() {
    return this.standardValue;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getUncompensatedCarePayment() {
    return this.uncompensatedCarePayment;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public BigDecimal getValueBasedPurchasingAdjustmentPayment() {
    return this.valueBasedPurchasingAdjustmentPayment;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setBundledAdjustmentPayment(final BigDecimal bundledAdjustmentPayment) {
    this.bundledAdjustmentPayment = bundledAdjustmentPayment;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setElectronicHealthRecordAdjustmentPayment(final BigDecimal electronicHealthRecordAdjustmentPayment) {
    this.electronicHealthRecordAdjustmentPayment = electronicHealthRecordAdjustmentPayment;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setHospitalAcquiredConditionPayment(final BigDecimal hospitalAcquiredConditionPayment) {
    this.hospitalAcquiredConditionPayment = hospitalAcquiredConditionPayment;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setHospitalReadmissionReductionAdjustmentPayment(final BigDecimal hospitalReadmissionReductionAdjustmentPayment) {
    this.hospitalReadmissionReductionAdjustmentPayment = hospitalReadmissionReductionAdjustmentPayment;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setStandardValue(final BigDecimal standardValue) {
    this.standardValue = standardValue;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setUncompensatedCarePayment(final BigDecimal uncompensatedCarePayment) {
    this.uncompensatedCarePayment = uncompensatedCarePayment;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public void setValueBasedPurchasingAdjustmentPayment(final BigDecimal valueBasedPurchasingAdjustmentPayment) {
    this.valueBasedPurchasingAdjustmentPayment = valueBasedPurchasingAdjustmentPayment;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public boolean equals(final java.lang.Object o) {
    if (o == this) return true;
    if (!(o instanceof AdditionalPaymentInformationData)) return false;
    final AdditionalPaymentInformationData other = (AdditionalPaymentInformationData) o;
    if (!other.canEqual((java.lang.Object) this)) return false;
    final java.lang.Object this$bundledAdjustmentPayment = this.getBundledAdjustmentPayment();
    final java.lang.Object other$bundledAdjustmentPayment = other.getBundledAdjustmentPayment();
    if (this$bundledAdjustmentPayment == null ? other$bundledAdjustmentPayment != null : !this$bundledAdjustmentPayment.equals(other$bundledAdjustmentPayment)) return false;
    final java.lang.Object this$electronicHealthRecordAdjustmentPayment = this.getElectronicHealthRecordAdjustmentPayment();
    final java.lang.Object other$electronicHealthRecordAdjustmentPayment = other.getElectronicHealthRecordAdjustmentPayment();
    if (this$electronicHealthRecordAdjustmentPayment == null ? other$electronicHealthRecordAdjustmentPayment != null : !this$electronicHealthRecordAdjustmentPayment.equals(other$electronicHealthRecordAdjustmentPayment)) return false;
    final java.lang.Object this$hospitalAcquiredConditionPayment = this.getHospitalAcquiredConditionPayment();
    final java.lang.Object other$hospitalAcquiredConditionPayment = other.getHospitalAcquiredConditionPayment();
    if (this$hospitalAcquiredConditionPayment == null ? other$hospitalAcquiredConditionPayment != null : !this$hospitalAcquiredConditionPayment.equals(other$hospitalAcquiredConditionPayment)) return false;
    final java.lang.Object this$hospitalReadmissionReductionAdjustmentPayment = this.getHospitalReadmissionReductionAdjustmentPayment();
    final java.lang.Object other$hospitalReadmissionReductionAdjustmentPayment = other.getHospitalReadmissionReductionAdjustmentPayment();
    if (this$hospitalReadmissionReductionAdjustmentPayment == null ? other$hospitalReadmissionReductionAdjustmentPayment != null : !this$hospitalReadmissionReductionAdjustmentPayment.equals(other$hospitalReadmissionReductionAdjustmentPayment)) return false;
    final java.lang.Object this$standardValue = this.getStandardValue();
    final java.lang.Object other$standardValue = other.getStandardValue();
    if (this$standardValue == null ? other$standardValue != null : !this$standardValue.equals(other$standardValue)) return false;
    final java.lang.Object this$uncompensatedCarePayment = this.getUncompensatedCarePayment();
    final java.lang.Object other$uncompensatedCarePayment = other.getUncompensatedCarePayment();
    if (this$uncompensatedCarePayment == null ? other$uncompensatedCarePayment != null : !this$uncompensatedCarePayment.equals(other$uncompensatedCarePayment)) return false;
    final java.lang.Object this$valueBasedPurchasingAdjustmentPayment = this.getValueBasedPurchasingAdjustmentPayment();
    final java.lang.Object other$valueBasedPurchasingAdjustmentPayment = other.getValueBasedPurchasingAdjustmentPayment();
    if (this$valueBasedPurchasingAdjustmentPayment == null ? other$valueBasedPurchasingAdjustmentPayment != null : !this$valueBasedPurchasingAdjustmentPayment.equals(other$valueBasedPurchasingAdjustmentPayment)) return false;
    return true;
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  protected boolean canEqual(final java.lang.Object other) {
    return other instanceof AdditionalPaymentInformationData;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public int hashCode() {
    final int PRIME = 59;
    int result = 1;
    final java.lang.Object $bundledAdjustmentPayment = this.getBundledAdjustmentPayment();
    result = result * PRIME + ($bundledAdjustmentPayment == null ? 43 : $bundledAdjustmentPayment.hashCode());
    final java.lang.Object $electronicHealthRecordAdjustmentPayment = this.getElectronicHealthRecordAdjustmentPayment();
    result = result * PRIME + ($electronicHealthRecordAdjustmentPayment == null ? 43 : $electronicHealthRecordAdjustmentPayment.hashCode());
    final java.lang.Object $hospitalAcquiredConditionPayment = this.getHospitalAcquiredConditionPayment();
    result = result * PRIME + ($hospitalAcquiredConditionPayment == null ? 43 : $hospitalAcquiredConditionPayment.hashCode());
    final java.lang.Object $hospitalReadmissionReductionAdjustmentPayment = this.getHospitalReadmissionReductionAdjustmentPayment();
    result = result * PRIME + ($hospitalReadmissionReductionAdjustmentPayment == null ? 43 : $hospitalReadmissionReductionAdjustmentPayment.hashCode());
    final java.lang.Object $standardValue = this.getStandardValue();
    result = result * PRIME + ($standardValue == null ? 43 : $standardValue.hashCode());
    final java.lang.Object $uncompensatedCarePayment = this.getUncompensatedCarePayment();
    result = result * PRIME + ($uncompensatedCarePayment == null ? 43 : $uncompensatedCarePayment.hashCode());
    final java.lang.Object $valueBasedPurchasingAdjustmentPayment = this.getValueBasedPurchasingAdjustmentPayment();
    result = result * PRIME + ($valueBasedPurchasingAdjustmentPayment == null ? 43 : $valueBasedPurchasingAdjustmentPayment.hashCode());
    return result;
  }

  @java.lang.Override
  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public java.lang.String toString() {
    return "AdditionalPaymentInformationData(bundledAdjustmentPayment=" + this.getBundledAdjustmentPayment() + ", electronicHealthRecordAdjustmentPayment=" + this.getElectronicHealthRecordAdjustmentPayment() + ", hospitalAcquiredConditionPayment=" + this.getHospitalAcquiredConditionPayment() + ", hospitalReadmissionReductionAdjustmentPayment=" + this.getHospitalReadmissionReductionAdjustmentPayment() + ", standardValue=" + this.getStandardValue() + ", uncompensatedCarePayment=" + this.getUncompensatedCarePayment() + ", valueBasedPurchasingAdjustmentPayment=" + this.getValueBasedPurchasingAdjustmentPayment() + ")";
  }

  @java.lang.SuppressWarnings("all")
  @lombok.Generated
  public AdditionalPaymentInformationData() {
  }
}
